#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf apmd_3.2.2.orig.tar.gz
    cd apmd-3.2.2.orig
    make CFLAGS="$CFLAGS"
    gcc -o apm .libs/apm.o .libs/libapm.a
    gcc -o apmd .libs/apmd.o .libs/libapm.a
    strip -R .note -R .comment apm apmd
    mkdir -p ../apmd/bin ../apmd/sbin
    cp apm ../apmd/bin/
    cp apmd ../apmd/sbin/
    cd ..
    rm -rf apmd-3.2.2.orig
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
